/*
 * color_picker.java
 * Copyright (C) 1999 Slava Pestov
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


import javax.swing.JColorChooser;
import java.awt.Color;
import org.gjt.sp.jedit.textarea.JEditTextArea;
import org.gjt.sp.jedit.EditAction;
import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.jedit.View;


public class color_picker extends EditAction
{
    public color_picker() {
        super("color-picker");
    }


    public void invoke(View view) {
        JEditTextArea textArea = view.getTextArea();

        String selection = textArea.getSelectedText();
        Color color;
        if (selection != null) {
            color = GUIUtilities.parseColor(selection);
        } else {
            color = null;
        }

        color = JColorChooser.showDialog(view,jEdit.getProperty(
            "colorChooser.title"),color);

        if (color != null) {
            textArea.setSelectedText(GUIUtilities.getColorHexString(color));
        }
    }
}
